﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Markup;
using System.Xml;

namespace MeinXAMLPad
{
  /// <summary>
  /// Interaction logic for MainWindow.xaml
  /// </summary>
  public partial class MainWindow : Window
  {
    UIElement uie = null;

    public MainWindow()
    {
      InitializeComponent();
      InitTextBox();
    }

    private void InitTextBox()
    {
      // Startext in die TextBox schreiben
      textCode.Text = "<Grid xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\"\r\n";
      textCode.AppendText("  xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\"\r\n");
      textCode.AppendText("  >\r\n  \r\n</Grid>\r\n");
      textCode.Focus();
    }

    private void OnClear(object sender, RoutedEventArgs e)
    {
      if (uie != null)
      {
        // Existierende WPF-Elemente entfernen
        gridCode.Children.Remove(uie);
        uie = null;
      }

      InitTextBox();
    }

    private void OnCompile(object sender, RoutedEventArgs e)
    {
      // WPF-Elemente im Grid darstellen
      if (uie != null)
      {
        // Existierende WPF-Elemente entfernen
        gridCode.Children.Remove(uie);
      }

      // WPF-Code aus TextBox übersetzen
      uie = GetTheCode(textCode.Text);

      if (uie != null)
      {
        // WPF im Grid darstellen
        gridCode.Children.Add(uie);
      }
    }

    private UIElement GetTheCode(string strText)
    {
      UIElement code = null;

      try
      {
        // Stream aus dem Eingabetext erzeugen
        StringReader stringReader = new StringReader(strText);
        // Text aus TextBox als XmlReader darstellen
        XmlReader xmlReader = XmlReader.Create(stringReader);
        // Laden und übersetzen des XAML-Codes, Zuordnung zum UIElement
        code = (UIElement)XamlReader.Load(xmlReader);
      }
      catch (Exception ex)
      {
        // Einfachste Fehlerbehandlung
        System.Windows.MessageBox.Show("Fehler mit XAML-Code:\n\n" + ex.Message);
      }

      return code;
    }

    private void OnExit(object sender, RoutedEventArgs e)
    {
      // Applikation schließen
      this.Close();
    }
  }
}
