﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace NeuRoutedCmd
{
  public class MyCommands
  {
    // Neuen Befehl definieren
    public static readonly RoutedUICommand MySpecialCommand =
      new RoutedUICommand("MyCommand", "MyCommand", typeof(MyCommands));
  }

  public partial class MainWindow : Window
  {
    public MainWindow()
    {
      InitializeComponent();

      // Befehl an Ereignismethoden binden
      CommandBinding cmd = new CommandBinding(MyCommands.MySpecialCommand);
      cmd.CanExecute += MySpecialCommand_CanExec;
      cmd.Executed += MySpecialCommand_Exec;
      this.CommandBindings.Add(cmd);
    }

    private void MySpecialCommand_CanExec(object sender, CanExecuteRoutedEventArgs e)
    {
      // e.CanExecute = true  --- UI-Elemente sind aktiviert
      // e.CanExecute = false --- UI-Elemente sind deaktiviert
      e.CanExecute = true;   // false;
    }

    private void MySpecialCommand_Exec(object sender, ExecutedRoutedEventArgs e)
    {
      MessageBox.Show("Ber Button wurde geklickt!");
    }
  }
}
