﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace TestToolbar
{
  public partial class MainWindow : Window
  {
    public MainWindow()
    {
      InitializeComponent();

      text.Focus();

      CommandBinding cbNeu = new CommandBinding(ApplicationCommands.New);
      cbNeu.Executed += new ExecutedRoutedEventHandler(OnNeu);
      cbNeu.CanExecute += new CanExecuteRoutedEventHandler(OnNeuCanExecute);
      this.CommandBindings.Add(cbNeu);

      CommandBinding cbAusschneiden = new CommandBinding(ApplicationCommands.Cut);
      cbAusschneiden.Executed += new ExecutedRoutedEventHandler(OnAusschneiden);
      cbAusschneiden.CanExecute += new CanExecuteRoutedEventHandler(OnAusschneidenCanExecute);
      this.CommandBindings.Add(cbAusschneiden);

      CommandBinding cbEinfuegen = new CommandBinding(ApplicationCommands.Paste);
      cbEinfuegen.Executed += new ExecutedRoutedEventHandler(OnEinfuegen);
      cbEinfuegen.CanExecute += new CanExecuteRoutedEventHandler(OnEinfuegenCanExecute);
      this.CommandBindings.Add(cbEinfuegen);

      CommandBinding cbKopieren = new CommandBinding(ApplicationCommands.Copy);
      cbKopieren.Executed += new ExecutedRoutedEventHandler(OnKopieren);
      cbKopieren.CanExecute += new CanExecuteRoutedEventHandler(OnAusschneidenCanExecute);
      this.CommandBindings.Add(cbKopieren);
    }

    private void OnNeu(object sender, RoutedEventArgs e)
    {
      text.Clear();
    }

    void OnNeuCanExecute(object sender, CanExecuteRoutedEventArgs e)
    {
      e.CanExecute = (text.Text.Length > 0);
    }

    private void OnBeenden(object sender, RoutedEventArgs e)
    {
      this.Close();
    }

    private void OnAusschneiden(object sender, RoutedEventArgs e)
    {
      text.Cut();
    }

    void OnAusschneidenCanExecute(object sender, CanExecuteRoutedEventArgs e)
    {
      e.CanExecute = (text.SelectedText.Length > 0);
    }

    private void OnEinfuegen(object sender, RoutedEventArgs e)
    {
      text.Paste();
    }

    void OnEinfuegenCanExecute(object sender, CanExecuteRoutedEventArgs e)
    {
      e.CanExecute = Clipboard.ContainsText();
    }

    private void OnKopieren(object sender, RoutedEventArgs e)
    {
      text.Copy();
    }

    private void OnAllesMarkieren(object sender, RoutedEventArgs e)
    {
      text.SelectAll();
    }

    private void OnSuchenStart(object sender, RoutedEventArgs e)
    {
      int iPos = text.SelectionStart + text.SelectionLength;
      string strText = text.Text;
      iPos = strText.IndexOf(textSuchen.Text, iPos);

      if (iPos >= 0)
      {
        text.Select(iPos, textSuchen.Text.Length);
      }
      else
      {
        text.Select(0, 0);
      }
    }
  }
}
