﻿using System;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.IO;

namespace TreeViewDir
{
  public partial class MainWindow : Window
  {
    private object dummy = null;

    public MainWindow()
    {
      InitializeComponent();
    }

    private void Window_Loaded(object sender, RoutedEventArgs e)
    {
      foreach (string str in Environment.GetLogicalDrives())
      {
        TreeViewItem tvi = new TreeViewItem();
        tvi.Header = str;
        tvi.Tag = str;
        tvi.Items.Add(dummy);
        tree.Items.Add(tvi);
      }
    }

    private void TVI_Expanded(object sender, RoutedEventArgs e)
    {
      TreeViewItem tvi = e.OriginalSource as TreeViewItem;

      if (tvi != null)
      {
        if ((tvi.Items.Count == 1) && (tvi.Items[0] == dummy))
        {
          tvi.Items.Clear();

          try
          {
            foreach (string str in Directory.GetDirectories(tvi.Tag.ToString()))
            {
              TreeViewItem subTvi = new TreeViewItem();
              subTvi.Header = str.Substring(str.LastIndexOf('\\') + 1);
              subTvi.Tag = str;
              subTvi.Items.Add(dummy);
              tvi.Items.Add(subTvi);
            }
          }
          catch (UnauthorizedAccessException)
          {
            MessageBox.Show("Zugriff verweigert.");
          }
          catch (IOException)
          {
            MessageBox.Show("Allgemeiner Fehler.");
          }
        }
      }
    }
  }
}
