﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CircPanel
{
  public partial class MainWindow : Window
  {
    //CirclePanel c = new CirclePanel();

    public MainWindow()
    {
      InitializeComponent();

      //for (int i = 0; i < 7; i++)
      //{
      //  Button b = new Button();
      //  b.Content = "Test " + i.ToString();
      //  c.Children.Add(b);
      //}

      //this.Content = c;
    }
  }

  public class CirclePanel : Panel
  {
    private double dDurchmesser;
    private int iCount;
    private double dPhi;
    double dMaxWidth;
    double dMaxHeight;

    protected override Size MeasureOverride(Size availableSize)
    {
      // Alle Kindelemente bekommen die gleiche Größe und
      // zwar die des größten Elements

      dMaxWidth = 0.0;
      dMaxHeight = 0.0;
      iCount = 0;

      foreach (UIElement child in this.Children)
      {
        // Standardgröße ermitteln

        child.Measure(new Size(double.PositiveInfinity, double.PositiveInfinity));
        Size childSize = child.DesiredSize;

        // Größte Breite und Höhe ermitteln

        if (childSize.Height > dMaxHeight)
        {
          dMaxHeight = childSize.Height;
        }

        if (childSize.Width > dMaxWidth)
        {
          dMaxWidth = childSize.Width;
        }

        // Anzahl ermitteln

        iCount++;
      }

      // Winkel für jedes Element auf dem Kreis ermitteln

      dPhi = 2.0 * Math.PI / iCount;

      // Durchmesser des Kreises ermitteln

      dDurchmesser = dMaxWidth / (Math.Sin(dPhi / 2.0));

      // Durchmesser um max. Höhe der Elemente erweitern
      // Kreis liegt jeweils auf den Zentren der Buttons

      dDurchmesser += dMaxHeight;

      return new Size(dDurchmesser, dDurchmesser);
    }

    protected override Size ArrangeOverride(Size finalSize)
    {
      // An den vorgegebenen Bereich des Layout-Systems anpassen

      dDurchmesser = Math.Min(finalSize.Width, finalSize.Height) - dMaxWidth;

      // Achtung: Durchmesser kleiner Null nicht erlaubt

      if (dDurchmesser < 0.0)
      {
        dDurchmesser = 0.0;
      }

      Point pos = new Point();
      double dWinkel = 0.0;

      // Positionierung aller Elemente auf dem Kreis
      // Die Mittelpunkte der Kindelemente liegen auf den Kreis

      foreach (UIElement child in Children)
      {
        // Ein bisschen Mathematik: Die Position berechnen…

        pos.X = (dDurchmesser / 2.0) * Math.Sin(dWinkel) + dDurchmesser / 2.0 - dMaxWidth / 2.0;
        pos.Y = -(dDurchmesser / 2.0) * Math.Cos(dWinkel) + dDurchmesser / 2.0 - dMaxHeight / 2.0;

        // Position dem layout-System mitteilen

        Rect childRect = new Rect(pos, new Size(dMaxWidth, dMaxHeight));
        child.Arrange(childRect);

        dWinkel += dPhi;
      }

      // Endgültige Größe zurückgeben

      return new Size(dDurchmesser, dDurchmesser);
    }
  }
}
