﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace HitTesting
{
  public partial class MainWindow : Window
  {
    public MainWindow()
    {
      InitializeComponent();
    }

    private void OnMouseDown(object sender, MouseEventArgs e)
    {
      // Mausposition ermitteln
      Point pt = e.GetPosition((UIElement)sender);

      // Fläche für Trefferbereich festlegen
      EllipseGeometry newHitTestArea = new EllipseGeometry(pt, 20.0, 20.0);

      // Rückrufprozedur für einen Treffer einrichten
      VisualTreeHelper.HitTest(path, null, new HitTestResultCallback(HitResult),
          new GeometryHitTestParameters(newHitTestArea));
    }

    public HitTestResultBehavior HitResult(HitTestResult result)
    {
      // Ermittlung des Hit-Test-Ergebnisses
      IntersectionDetail detail = ((GeometryHitTestResult)result).IntersectionDetail;

      switch (detail)
      {
        case IntersectionDetail.FullyContains:
          MessageBox.Show("Voll getroffen!");
          return HitTestResultBehavior.Stop;

        case IntersectionDetail.Intersects:
          MessageBox.Show("Teilweise getroffen!");
          return HitTestResultBehavior.Continue;

        case IntersectionDetail.FullyInside:
          MessageBox.Show("Vollständig innen!");
          return HitTestResultBehavior.Continue;

        default:
          return HitTestResultBehavior.Stop;

      }
    }
  }
}
