﻿using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Controls;

namespace HitTestAni
{
  public partial class MainWindow : Window
  {
    DoubleAnimation anim1 = new DoubleAnimation();
    DoubleAnimation anim2 = new DoubleAnimation();
    DoubleAnimation anim3 = new DoubleAnimation();
    DoubleAnimation anim4 = new DoubleAnimation();
    DoubleAnimation anim5 = new DoubleAnimation();

    Random rand = new Random(DateTime.Now.Second);

    public MainWindow()
    {
      InitializeComponent();
    }

    private void OnLoaded(object sender, RoutedEventArgs e)
    {
      InitAnimation(anim1, OnCompleted1);
      InitAnimation(anim2, OnCompleted2);
      InitAnimation(anim3, OnCompleted3);
      InitAnimation(anim4, OnCompleted4);
      InitAnimation(anim5, OnCompleted5);
    }

    private void InitAnimation(DoubleAnimation anim, EventHandler handler)
    {
      anim.FillBehavior = FillBehavior.HoldEnd;
      anim.AccelerationRatio = 0.2;
      anim.DecelerationRatio = 0.2;
      anim.Completed += handler;
      handler(anim, new EventArgs());
    }

    private void OnCompleted1(object sender, EventArgs e)
    {
      anim1.Duration = new Duration(TimeSpan.FromSeconds(rand.Next(1, 3)));
      anim1.To = rand.Next(10, 450);
      btn.BeginAnimation(Canvas.LeftProperty, anim1);
    }

    private void OnCompleted2(object sender, EventArgs e)
    {
      anim2.Duration = new Duration(TimeSpan.FromSeconds(rand.Next(1, 3)));
      anim2.To = rand.Next(10, 200);
      btn.BeginAnimation(Canvas.TopProperty, anim2);
    }

    private void OnCompleted3(object sender, EventArgs e)
    {
      anim3.Duration = new Duration(TimeSpan.FromSeconds(rand.Next(1, 3)));
      anim3.To = rand.NextDouble() * 360.0;
      rot.BeginAnimation(RotateTransform.AngleProperty, anim3);
    }

    private void OnCompleted4(object sender, EventArgs e)
    {
      anim4.Duration = new Duration(TimeSpan.FromSeconds(rand.Next(1, 3)));
      anim4.To = rand.NextDouble() * 2.0 + 0.2;
      scale.BeginAnimation(ScaleTransform.ScaleXProperty, anim4);
    }

    private void OnCompleted5(object sender, EventArgs e)
    {
      anim5.Duration = new Duration(TimeSpan.FromSeconds(rand.Next(1, 3)));
      anim5.To = rand.NextDouble() * 2.0 + 0.2;
      scale.BeginAnimation(ScaleTransform.ScaleYProperty, anim5);
    }

    private void OnClicked(object sender, RoutedEventArgs e)
    {
      MessageBox.Show("Getroffen!!!");
    }
  }
}
