﻿using System;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace VieleAnimationen
{
  public partial class MainWindow : Window
  {
    // Hier kann die Anzahl der Linien geändert werden
    // Anzahl der Animationen = 4 * Anzahl der Linien
    private const int iLinienAnzahl = 10;

    public MainWindow()
    {
      InitializeComponent();
    }

    private void WindowLoaded(object sender, RoutedEventArgs e)
    {
      // Zufallszahlengenerator initialisieren
      Random r = new Random((int)DateTime.Now.Ticks);

      // Größe des Containers festellen
      int iXSize = (int)(container.ActualWidth + 0.5);
      int iYSize = (int)(container.ActualHeight + 0.5);

      // Schleife für alle Linien
      for (int i = 0; i < iLinienAnzahl; i++)
      {
        // Linienobjekt erstellen
        Line l = new Line();
        l.X1 = r.Next(iXSize);
        l.Y1 = r.Next(iYSize);
        l.X2 = r.Next(iXSize);
        l.Y2 = r.Next(iYSize);

        // Brush für Linie erstellen
        Color col = new Color();
        col.R = (byte)r.Next(255);
        col.G = (byte)r.Next(255);
        col.B = (byte)r.Next(255);
        col.A = (byte)r.Next(128, 255);
        SolidColorBrush brush = new SolidColorBrush(col);

        l.Stroke = brush;
        l.StrokeThickness = r.Next(1,10);

        // In das Canvas einfügen
        container.Children.Add(l);

        // Fünf Animationen erstellen
        DoubleAnimation da1 = new DoubleAnimation();
        da1.Duration = new Duration(TimeSpan.FromSeconds(r.Next(10)));
        da1.To = r.Next(iXSize);
        da1.AutoReverse = true;
        da1.RepeatBehavior = RepeatBehavior.Forever;

        DoubleAnimation da2 = new DoubleAnimation();
        da2.Duration = new Duration(TimeSpan.FromSeconds(r.Next(10)));
        da2.To = r.Next(iYSize);
        da2.AutoReverse = true;
        da2.RepeatBehavior = RepeatBehavior.Forever;

        DoubleAnimation da3 = new DoubleAnimation();
        da3.Duration = new Duration(TimeSpan.FromSeconds(r.Next(10)));
        da3.To = r.Next(iXSize);
        da3.AutoReverse = true;
        da3.RepeatBehavior = RepeatBehavior.Forever;

        DoubleAnimation da4 = new DoubleAnimation();
        da4.Duration = new Duration(TimeSpan.FromSeconds(r.Next(10)));
        da4.To = r.Next(iYSize);
        da4.AutoReverse = true;
        da4.RepeatBehavior = RepeatBehavior.Forever;

        DoubleAnimation da5 = new DoubleAnimation();
        da5.Duration = new Duration(TimeSpan.FromSeconds(r.Next(10)));
        da5.To = r.Next(1,10);
        da5.AutoReverse = true;
        da5.RepeatBehavior = RepeatBehavior.Forever;

        // Animationen starten
        l.BeginAnimation(Line.X1Property, da1);
        l.BeginAnimation(Line.Y1Property, da2);
        l.BeginAnimation(Line.X2Property, da3);
        l.BeginAnimation(Line.Y2Property, da4);
        l.BeginAnimation(Line.StrokeThicknessProperty, da5);
      }
    }
  }
}
