﻿using System;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;
using System.Windows.Media;
using System.ComponentModel;
using System.Windows.Threading;

namespace BindingTimer
{
  public partial class MainWindow : Window
  {
    public MainWindow()
    {
      InitializeComponent();
    }
  }

  // Klasse für die Uhr
  public class MyClock : INotifyPropertyChanged
  {
    #region INotifyPropertyChanged Members

    public event PropertyChangedEventHandler PropertyChanged;

    #endregion

    DispatcherTimer dt;

    public MyClock()
    {
      dt = new DispatcherTimer();
      dt.Interval = TimeSpan.FromSeconds(1);
      dt.Tick += dt_Tick;
      dt.Start();
    }

    // Timer-Methode: Wird jede Sekunde einmal aufgerufen
    void dt_Tick(object sender, EventArgs e)
    {
      if (this.PropertyChanged != null)
      {
        this.PropertyChanged(this, new PropertyChangedEventArgs("AktuelleZeit"));
        this.PropertyChanged(this, new PropertyChangedEventArgs("Sekunden"));
        this.PropertyChanged(this, new PropertyChangedEventArgs("Minuten"));
        this.PropertyChanged(this, new PropertyChangedEventArgs("Stunden"));
      }
    }

    // Öffentliche Eigenschaften, an die gebunden werden kann
    public string AktuelleZeit
    {
      get { return DateTime.Now.ToString(); }
      set { }
    }

    public int Sekunden
    {
      get { return DateTime.Now.Second; }
      set { }
    }

    public int Minuten
    {
      get { return DateTime.Now.Minute; }
      set { }
    }

    public int Stunden
    {
      get { return DateTime.Now.Hour; }
      set { }
    }
  }
}
