﻿using System;
using System.ComponentModel;

namespace BindungContext
{
  class DataClass : INotifyPropertyChanged
  {
    private string strNachname;
    private string strVorname;
    private int iJahr;

    public event PropertyChangedEventHandler PropertyChanged;

    public DataClass()
    {
      strNachname = "Test";
      strVorname = "Test";
      iJahr = 0;
    }

    public DataClass(string strV, string strN, int iJ)
    {
      strVorname = strV;
      strNachname = strN;
      iJahr = iJ;
    }

    public string Nachname
    {
      set
      {
        strNachname = value;
        OnPropertyChanged("Nachname");
      }
      get { return strNachname; }
    }

    public string Vorname
    {
      set
      {
        strVorname = value;
        OnPropertyChanged("Vorname");
      }
      get { return strVorname; }
    }

    public int Jahr
    {
      set
      {
        iJahr = value;
        OnPropertyChanged("Jahr");
      }
      get { return iJahr; }
    }

    protected void OnPropertyChanged(string strPropName)
    {
      PropertyChangedEventHandler handler = PropertyChanged;

      if (handler != null)
      {
        handler(this, new PropertyChangedEventArgs(strPropName));
      }
    }
  }
}
