﻿using System;
using System.Windows;
using System.Windows.Input;
using System.Windows.Controls;

namespace BindungLupe
{
  public partial class MainWindow : Window
  {
    private readonly double dSize = 50;

    public MainWindow()
    {
      InitializeComponent();
    }

    private void OnMouseMove(object sender, MouseEventArgs e)
    {
      // Mauszeiger wieder als Pfeil darstellen
      Mouse.SetCursor(Cursors.Arrow);

      // Aktuelle Position des Mauszeigers relativ zum Fenster
      Point currPos = e.GetPosition(this);

      // Muss die Lupe rechts oder links vom Mauszeiger dargestellt werden
      if (this.ActualWidth - currPos.X > lupe.Width)
      {
        Canvas.SetLeft(lupe, currPos.X);
      }
      else
      {
        Canvas.SetLeft(lupe, currPos.X - lupe.Width);
      }

      // Muss die Lupe obenhalb oder unterhalb vom Mauszeiger dargestellt werden
      if (this.ActualHeight - currPos.Y > lupe.Height)
      {
        Canvas.SetTop(lupe, currPos.Y);
      }
      else
      {
        Canvas.SetTop(lupe, currPos.Y - lupe.Height);
      }

      // Nun die Viewbox des VisualBrush-Elements mit dem Bereich um den
      // Mauszeiger herum aktualisieren. Der Inhalt wird dabei vergrößert.
      visual.Viewbox = new Rect(currPos.X - dSize / 2, currPos.Y - dSize / 2, dSize, dSize);
    }
  }
}
