﻿using System;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Xml;

namespace ConverterParam
{
  public partial class MainWindow : Window
  {
    public MainWindow()
    {
      InitializeComponent();
    }
  }

  public class MultiConverter : IValueConverter
  {
    #region IValueConverter Members

    public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
    {
      if (parameter != null)
      {
        double dParam = XmlConvert.ToDouble(parameter.ToString());
        return ((double)value) * dParam;
      }
      else
      {
        return value;
      }
    }

    public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
    {
      double x;

      if (parameter != null)
      {
        if (double.TryParse((string)value, out x))
          return x / XmlConvert.ToDouble(parameter.ToString());

        return Binding.DoNothing;
      }
      else
      {
        if (double.TryParse((string)value, out x))
          return x;

        return Binding.DoNothing;
      }
    }

    #endregion
  }
}
