﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Input;

namespace MVVM
{
  class AstroObjectViewModel : INotifyPropertyChanged
  {
    private AstroObject _astroObject;

    public AstroObjectViewModel()
    {
      _astroObject = new AstroObject
      {
        ObjectName = "Star #1",
        ObjectType = ObjectType.Stern,
        Magnitude = 5.6f,
        Description = "Ein schöner Stern"
      };
    }

    public AstroObject AstroObject
    {
      get { return _astroObject; }
      set { _astroObject = value; }
    }

    public string ObjectName
    {
      get { return AstroObject.ObjectName; }
      set
      {
        if (AstroObject.ObjectName != value)
        {
          AstroObject.ObjectName = value;
          RaisePropertyChanged("ObjectName");
        }
      }
    }

    public float Magnitude
    {
      get { return AstroObject.Magnitude; }
      set
      {
        if (AstroObject.Magnitude != value)
        {
          AstroObject.Magnitude = value;
          RaisePropertyChanged("Magnitude");
        }
      }
    }

    public ObjectType ObjectType
    {
      get { return AstroObject.ObjectType; }
      set
      {
        if (AstroObject.ObjectType != value)
        {
          AstroObject.ObjectType = value;
          RaisePropertyChanged("ObjectType");
        }
      }
    }

    public string Description
    {
      get { return AstroObject.Description; }
      set
      {
        if (AstroObject.Description != value)
        {
          AstroObject.Description = value;
          RaisePropertyChanged("Description");
        }
      }
    }

    #region INotifyPropertyChanged Members

    public event PropertyChangedEventHandler PropertyChanged;

    #endregion
    
    private void RaisePropertyChanged(string propertyName)
    {
      // Kopie erstellen, um Threading-Probleme zu vermeiden
      PropertyChangedEventHandler handler = PropertyChanged;

      if (handler != null)
      {
        handler(this, new PropertyChangedEventArgs(propertyName));
      }
    }

    // Command-Handler
    public ICommand UpdateAstroObject
    {
      get
      {
        return new RelayCommand(UpdateAstroObjectExecute, CanUpdateAstroObjectExecute);
      }
    }

    void UpdateAstroObjectExecute()
    {
      this.ObjectName = "Nebel #1";
      this.Magnitude = 12.2f;
      this.ObjectType = ObjectType.Nebel;
      this.Description = "Ein wunderschöner Nebel";
    }

    bool CanUpdateAstroObjectExecute()
    {
      // Hier immer eingeschaltet
      return true;
    }
  }
}
