﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.Windows.Input;

namespace MVVM
{
  class SkyViewModel
  {
    private AstroDatabase _astroDB = new AstroDatabase();
    private ObservableCollection<AstroObjectViewModel> _astroObjects = new ObservableCollection<AstroObjectViewModel>();

    public ObservableCollection<AstroObjectViewModel> AstroObjects
    {
      get
      {
        return _astroObjects;
      }
      set
      {
        _astroObjects = value;
      }
    }

    public SkyViewModel()
    {
      for (int i = 0; i < 4; i++)
      {
        _astroObjects.Add(_astroDB.GetAstroObject(i));
      }
    }

    public ICommand UpdateSkyObjects 
    { 
      get 
      { 
        return new RelayCommand(UpdateSkyObjectExecute, CanUpdateSkyObjectExecute); 
      } 
    }

    void UpdateSkyObjectExecute()
    {
      if (_astroObjects == null) return;

      foreach (var obj in _astroObjects)
      {
        obj.ObjectName = "*** Änderung ***";
      }
    }

    bool CanUpdateSkyObjectExecute()
    {
      // Immer eingeschaltet
      return true;
    }

    public ICommand AddSkyObject 
    { 
      get 
      { 
        return new RelayCommand(AddSkyObjectExecute, CanAddSkyObjectExecute); 
      } 
    }

    void AddSkyObjectExecute()
    {
      if (_astroObjects == null) return;

      _astroObjects.Add(_astroDB.GetAstroObject(4));
    }

    bool CanAddSkyObjectExecute()
    {
      return true;
    }

  }
}
