﻿using System;
using System.Text;
using System.Windows.Controls;
using System.Globalization;

namespace ValidationTest
{
  public class AgeRangeRule : ValidationRule
  {
    private int _min = 0;
    private int _max = 130;

    public AgeRangeRule()
    {
    }

    // Eigenschaften, die von XAML aus gesetzt werden können
    public int Min
    {
      get { return _min; }
      set { _min = value; }
    }

    public int Max
    {
      get { return _max; }
      set { _max = value; }
    }

    // Prüfung der Daten
    public override ValidationResult Validate(object value, CultureInfo cultureInfo)
    {
      int age = 0;

      // Allgemeine Überprüfung
      try
      {
        if (((string)value).Length > 0)
        {
          age = int.Parse((string)value);
        }
      }
      catch (Exception e)
      {
        // Ein Standardfehler ist aufgetreten
        return new ValidationResult(false, "Nicht erlaubte Zeichen oder '" + e.Message + "'");
      }

      // Prüfung des Bereichs von... bis...
      if ((age < Min) || (age > Max))
      {
        // Fehler beim Bereich
        return new ValidationResult(false,
          "Bitte geben Sie ein Alter im Bereich von " + Min + " bis " + Max + " ein.");
      }
      else
      {
        // Alles OK!
        return new ValidationResult(true, null);
      }
    }
  }
}
