﻿using System;
using System.Windows;
using System.ComponentModel;

namespace Background
{
  public partial class MainWindow : Window
  {
    private double dSum = 0.0;
    BackgroundWorker back = null;

    public MainWindow()
    {
      InitializeComponent();

      back = new BackgroundWorker();

      // Ereignismethoden definieren
      back.DoWork += new DoWorkEventHandler(back_DoWork);
      back.RunWorkerCompleted += new RunWorkerCompletedEventHandler(back_Completed);
      back.ProgressChanged += new ProgressChangedEventHandler(back_ProgressChanged);

      // Unterstützung der Fortschrittsanzeige und des Abbruchs
      back.WorkerReportsProgress = true;
      back.WorkerSupportsCancellation = true;

      // Start der asynchronen Operation
      back.RunWorkerAsync();
    }

    private void back_DoWork(object sender, DoWorkEventArgs e)
    {
      for (int j = 0; j < 100; j++)
      {
        // Es wurde abgebrochen, jetzt Berechnungen beenden
        if (back.CancellationPending)
        {
          e.Cancel = true;
          return;
        }

        // Hier findet die berechnung statt
        for (int i = 0; i < 10000000; i++)
        {
          dSum += Math.Sqrt(j * 10000000 + i);
        }

        // Ausgabe des Fortschritts
        back.ReportProgress(j + 1);
      }
    }

    private void back_Completed(object sender, RunWorkerCompletedEventArgs e)
    {
      // Arbeit beendet
      if (e.Cancelled)
      {
        // Es wurde abgebrochen
        status.Value = 0;
      }
      else
      {
        // Es wurde alles beendet
        MessageBox.Show("Alles erledigt! Ergebnis: " + dSum.ToString());
      }
    }

    private void back_ProgressChanged(object sender, ProgressChangedEventArgs e)
    {
      // Fortschrittsanzeige
      status.Value = e.ProgressPercentage;
    }

    private void OnBeenden(object sender, RoutedEventArgs e)
    {
      // Abbrechen gedrückt
      back.CancelAsync();
    }
  }
}