﻿using System;
using System.Threading;
using System.Windows;
using System.Windows.Threading;
using System.Windows.Controls;

namespace Thread1
{
  public partial class MainWindow : Window
  {
    delegate void UpdateUIDelegate(Button thButton, bool bInvoked);
    Button btn = null;

    public MainWindow()
    {
      InitializeComponent();
    }

    private void OnClickNormal(object sender, RoutedEventArgs e)
    {
      btn = sender as Button;
      DoIt();
    }

    private void OnClickThread(object sender, RoutedEventArgs e)
    {
      btn = sender as Button;

      ThreadStart thStart = new ThreadStart(DoIt);
      Thread th = new Thread(thStart);
      th.Start();
    }

    private void DoIt()
    {
      if (btn != null)
      {
        // Darf dieser Thread auf das Objekt zugreifen?
        if (btn.Dispatcher.CheckAccess())
        {
          // Ja!
          UpdateButtonUI(btn, false);
        }
        else
        {
          // Nein!
          // Die Methode muss über die Invoke-Methode des  
          // Dispatcher-Objekts ausgeführt werden.
          UpdateUIDelegate delUpdate = new UpdateUIDelegate(UpdateButtonUI);
          btn.Dispatcher.Invoke(DispatcherPriority.Normal, delUpdate, btn, true);
        }
      }
    }

    private void UpdateButtonUI(Button btn, bool bInvoked)
    {
      if (bInvoked)
      {
        btn.Content = "WPF - Mit Invoke!";
      }
      else
      {
        btn.Content = "WPF - Ohne Invoke!";
      }
    }
  }
}
