﻿using System;
using System.Threading;
using System.Windows;
using System.Windows.Threading;
using System.Windows.Controls;

namespace Thread2
{
  public partial class MainWindow : Window
  {
    delegate void UpdateUIDelegate(Button thButton);
    Button btn = null;

    public MainWindow()
    {
      InitializeComponent();
    }

    private void OnClickThread(object sender, RoutedEventArgs e)
    {
      btn = sender as Button;

      ThreadStart thStart = new ThreadStart(DoIt);
      Thread th = new Thread(thStart);
      th.Start();
    }

    private void DoIt()
    {
      if (btn != null)
      {
        // Die Methode muss über die Invoke-Methode des  
        // Dispatcher-Objekts ausgeführt werden.
        UpdateUIDelegate delUpdate = new UpdateUIDelegate(UpdateButtonUI);
        DispatcherOperation dispOp = btn.Dispatcher.BeginInvoke(DispatcherPriority.Normal, delUpdate, btn);
        dispOp.Completed += new EventHandler(dispOp_Completed);

        if (dispOp.Status == DispatcherOperationStatus.Completed)
        {
          MessageBox.Show("Das ging aber schnell!");
        }
      }
    }

    void dispOp_Completed(object sender, EventArgs e)
    {
      MessageBox.Show("Es ist vollbracht!");
    }

    private void UpdateButtonUI(Button btn)
    {
      btn.Content = "WPF - Mit Invoke!";
      btn.FontSize = 18;
    }
  }
}