﻿using System;
using System.Text;
using System.Windows;
using System.Windows.Input;
using System.Windows.Controls;
using System.Diagnostics;
using System.Threading.Tasks;

namespace Wpf_TPL2
{
  public partial class MainWindow : Window
  {
    Stopwatch sw = new Stopwatch();
    object summeLock = new object();

    public MainWindow()
    {
      InitializeComponent();
    }

    private void OnButtonCalculate(object sender, RoutedEventArgs e)
    {
      // "Sanduhr" als Cursor
      this.Cursor = Cursors.Wait;

      // Zeitmessung starten
      sw.Reset();
      sw.Start();

      // Berechnung der Wurzelsumme
      double dSumme = 0.0;

      // Parallele Berechnung der Quadratwurzeln
      Parallel.For(0, 100000000, 
        () => 0.0,              // Initialisierung LocalState
        (i, pls, tls) =>        // Berechnung einer Teilsumme
        {
          tls += Math.Sqrt(i);
          return tls;
        },
        (teilSumme) =>          // Summierung der Teilsummen 
        {
          lock (summeLock)
          {
            dSumme += teilSumme;
          }
        });

      // Zeitmessung beenden
      sw.Stop();

      // Ausgabe Ergebnis und Zeit
      textBoxResult.Text = dSumme.ToString();
      textBlockZeit.Text = sw.ElapsedMilliseconds.ToString();

      // Cursor wieder auf den normalen Pfeil setzen
      this.Cursor = Cursors.Arrow;
    }
  }
}
