﻿using System;
using System.Text;
using System.Windows;
using System.Windows.Input;
using System.Windows.Controls;
using System.Diagnostics;
using System.Threading.Tasks;
using System.Windows.Threading;

namespace Wpf_TPL3
{
  public partial class MainWindow : Window
  {
    delegate void UpdateUIDelegate(double dResult, long iTime, bool bInvoke);
    Stopwatch sw = new Stopwatch();

    public MainWindow()
    {
      InitializeComponent();
    }

    private void OnButtonCalculate(object sender, RoutedEventArgs e)
    {
      // Start-Button ausschalten
      btnStart.IsEnabled = false;

      // Zeitmessung starten
      sw.Reset();
      sw.Start();

      // Nebenläufige Berechnung der Quadratwurzeln
      Task.Factory.StartNew(() =>
      {
        double dSumme = 0.0;

        for (int i = 0; i < 100000000; i++)
        {
          dSumme += Math.Sqrt(i);
        }

        return dSumme;

      }).ContinueWith(dTask => 
      {
        // Aufruf, wenn Berechnung beendet ist
        sw.Stop();

        // Sind wir im "richtigen" Thread?
        if (textBoxResult.Dispatcher.CheckAccess())
        {
          // Ja, direkte Ausgabe der Ergebnisse
          UpdateUI(dTask.Result, sw.ElapsedMilliseconds, false);
        }
        else
        {
          // Nein, Invoke benutzen
          UpdateUIDelegate delUpdate = new UpdateUIDelegate(UpdateUI);
          textBoxResult.Dispatcher.Invoke(DispatcherPriority.Normal, delUpdate, 
            dTask.Result, sw.ElapsedMilliseconds, true);
        }
      });
    }

    private void UpdateUI(double dResult, long iTime, bool bInvoke)
    {
      textBoxResult.Text = dResult.ToString() + " [" + bInvoke.ToString() + "]";
      textBlockZeit.Text = iTime.ToString();

      // Start-Button wieder einschalten
      btnStart.IsEnabled = true;
    }
  }
}
