﻿using System;
using System.Text;
using System.Windows;
using System.Windows.Input;
using System.Windows.Controls;
using System.Diagnostics;
using System.Threading.Tasks;

namespace Wpf_TPL5
{
  public partial class MainWindow : Window
  {
    Stopwatch sw = new Stopwatch();
    object summeLock = new object();

    public MainWindow()
    {
      InitializeComponent();
    }

    private void OnButtonCalculate(object sender, RoutedEventArgs e)
    {
      // Thread-Kontext für Ausgaben merken
      var uiKontext = TaskScheduler.FromCurrentSynchronizationContext();

      // Start-Button ausschalten
      btnStart.IsEnabled = false;

      // Zeitmessung starten
      sw.Reset();
      sw.Start();

      // Nebenläufige Berechnung der Quadratwurzeln
      Task.Factory.StartNew(() =>
      {
        double dSumme = 0.0;

        // Parallele Berechnung der Quadratwurzeln
        Parallel.For(0, 100000000,
          () => 0.0,              // Initialisierung LocalState
          (i, pls, tls) =>        // Berechnung einer Teilsumme
          {
            tls += Math.Sqrt(i);
            return tls;
          },
          (teilSumme) =>          // Summierung der Teilsummen 
          {
            lock (summeLock)
            {
              dSumme += teilSumme;
            }
          });

        return dSumme;

      }).ContinueWith(dTask => 
      {
        // Aufruf, wenn Berechnung beendet ist
        sw.Stop();

        // Ausgabe ist jetzt möglich
        textBoxResult.Text = dTask.Result.ToString();
        textBlockZeit.Text = sw.ElapsedMilliseconds.ToString();

        // Start-Button wieder einschalten
        btnStart.IsEnabled = true;
      
      }, uiKontext);
    }
  }
}
