﻿using System;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Threading;
using System.Windows.Shell;

namespace WPF_Taskbar5
{
  public partial class MainWindow : Window
  {
    DispatcherTimer dt = new DispatcherTimer();

    public MainWindow()
    {
      InitializeComponent();

      dt.Interval = TimeSpan.FromSeconds(1);
      dt.Tick += dt_Tick;
      dt.IsEnabled = false;
    }

    private void dt_Tick(object sender, EventArgs e)
    {
      this.TaskbarItemInfo.ProgressValue += 0.05;

      if (this.TaskbarItemInfo.ProgressValue >= 1.0)
      {
        dt.IsEnabled = false;
        this.TaskbarItemInfo.ProgressValue = 0.0;
      }
    }

    private void Start_Click(object sender, RoutedEventArgs e)
    {
      this.TaskbarItemInfo.ProgressState = TaskbarItemProgressState.Normal;
      dt.IsEnabled = true;
    }

    private void Stop_Click(object sender, RoutedEventArgs e)
    {
      this.TaskbarItemInfo.ProgressState = TaskbarItemProgressState.Error;
      dt.IsEnabled = false;
    }

    private void Reset_Click(object sender, RoutedEventArgs e)
    {
      this.TaskbarItemInfo.ProgressValue = 0.0;
      this.TaskbarItemInfo.ProgressState = TaskbarItemProgressState.None;
    }
  }
}
